package javax.swing.plaf.metal;

import sun.swing.SwingUtilities2;
import javax.swing.UIManager;
import java.awt.Graphics;
import javax.swing.JLabel;
import sun.awt.AppContext;
import javax.swing.plaf.ComponentUI;
import javax.swing.JComponent;
import javax.swing.plaf.basic.BasicLabelUI;

public class MetalLabelUI extends BasicLabelUI
{
    protected static MetalLabelUI metalLabelUI;
    private static final Object METAL_LABEL_UI_KEY;
    
    public MetalLabelUI() {
    }
    
    public static ComponentUI createUI(JComponent component) {
        if (System.getSecurityManager() != null) {
            AppContext appContext = AppContext.getAppContext();
            MetalLabelUI value = (MetalLabelUI)appContext.get(MetalLabelUI.METAL_LABEL_UI_KEY);
            if (value == null) {
                value = new MetalLabelUI();
                appContext.put(MetalLabelUI.METAL_LABEL_UI_KEY, value);
                return value;
            }
            return value;
        }
        else {
            return MetalLabelUI.metalLabelUI;
        }
    }
    
    @Override
    protected void paintDisabledText(JLabel c, Graphics g, String text, int x, int y) {
        int displayedMnemonicIndex = c.getDisplayedMnemonicIndex();
        g.setColor(UIManager.getColor("Label.disabledForeground"));
        SwingUtilities2.drawStringUnderlineCharAt(c, g, text, displayedMnemonicIndex, x, y);
    }
    
    static {
        MetalLabelUI.metalLabelUI = new MetalLabelUI();
        METAL_LABEL_UI_KEY = new Object();
    }
}
